//Helmet (Code taken from "OpenCharacterAssets")
// CUSTOMIZE SECTION START
local skin = "tatails" // your character here
local thebutton = BT_ATTACK // the button needed to do the parry
local sound = sfx_s3k8c // the sound of the parry
local sound2 = 	sfx_bnce1 // blocking sound
local parryframes = 70 // frames of the parry
local parrydelay = 4*TICRATE // the delay of parrying
local thrustspeed = 5 // how far enemies are thrusted
local cooldownhud = true // if this is true, the cooldown will be shown in a heads up display
// CUSTOMIZE SECTION END PROCCED BELOW IF YOU KNOW WHAT YOUR DOING

freeslot("MT_PARRYSHIELD")

mobjinfo[MT_PARRYSHIELD] =
{
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_HELM,
	deathstate = S_HELM,
	xdeathstate = S_HELM,
	radius = 42*FRACUNIT,
	height = 60*FRACUNIT,
	flags = MF_NOGRAVITY
}

hud.add(function(v,player)
	if player.mo and player.mo.skin == skin and player.weapondelay and cooldownhud == true
		local xpos = hudinfo[HUD_LIVES].x
		local ypos = hudinfo[HUD_LIVES].y
		v.drawString(xpos, (ypos - 39), ("COOLDOWN:" + (player.weapondelay)), V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	end
	if player.mo and player.mo.skin == skin and player.bombcooldown and cooldownhud == true
		local xpos = hudinfo[HUD_LIVES].x
		local ypos = hudinfo[HUD_LIVES].y
		v.drawString(xpos, (ypos - 39), ("COOLDOWN:" + (player.bombcooldown)), V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	end
	if player.mo and player.mo.skin == skin and player.robotcooldown and cooldownhud == true
		local xpos = hudinfo[HUD_LIVES].x
		local ypos = hudinfo[HUD_LIVES].y
		v.drawString(xpos, (ypos - 49), ("ROBOT REPAIR:" + (player.robotcooldown)), V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	end
end)

addHook("PlayerThink", function(player)
	if not ((player and player.valid) and (player.mo and player.mo.valid)) return end
	if player.mo.parrying == nil
		player.mo.parrying = false
	end
	if player.mo.parrytime == nil
		player.mo.parrytime = 0
	end
	
	if player.mo.parrytime > 0
		player.pflags = $|PF_FULLSTASIS
		player.mo.parrytime = $ - 1
		local shield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_PARRYSHIELD)
		shield.target = player.mo
		shield.scale = player.mo.scale*0
		shield.frame = $ |FF_TRANS50
		if not P_IsObjectOnGround(player.mo)
			player.mo.momz = $+FixedMul(P_GetMobjGravity(player.mo), 2*FRACUNIT)
		end
	end
	if player.mo.parrytime == 1
		player.mo.parrytime = 0
		player.mo.parrying = false
		player.pflags = $1 & ~PF_FULLSTASIS
		if not P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_FALL
			player.weapondelay = 0
		else
			player.mo.state = S_PLAY_STND
			player.weapondelay = parrydelay
		end
	end
	if player.mo and player.mo.skin == skin and player.tailshelmet and player.inventory[player.tailsselect] == "HELMET"
	and not player.tailssubbing
	and (player.cmd.buttons & thebutton)
	and player.mo.parrying == false
	and player.mo.parrytime == 0
	and not player.weapondelay
		S_StartSound(player.mo, sound)
		player.mo.parrytime = parryframes
		player.mo.state = S_HELM
	end
end)

addHook("MobjThinker", function(shield)
	if (shield.target and shield.target.valid) and (shield.target.parrytime == 0)
		P_RemoveMobj(shield)
	end
end, MT_PARRYSHIELD)

addHook("MobjDeath", function(enemy, player)
	if (player and player.valid and player.skin == "tatails" and (player.state == S_HELM or player.state == S_HELMB))
	and not P_IsObjectOnGround(player)
		if (enemy and enemy.valid and enemy.flags & (MF_ENEMY|MF_SHOOTABLE))
			player.parrytime = 2
			player.weapondelay = 0
			player.state = S_PLAY_FALL
		end
	end
end)

addHook("MobjCollide", function(shield, other)
	if (other.z > shield.z+shield.height) or (shield.z > other.z+other.height) return end
	if (other and other.valid) and (other.flags & MF_ENEMY)
	and shield.parrytime > 0 
		P_InstaThrust(other,shield.angle,FRACUNIT*thrustspeed*2)
		P_SetObjectMomZ(other, 5*FRACUNIT, false)
		S_StartSound(shield, sound2)
		other.target = shield
		other.flags = $&~MF_SPECIAL
		other.flags = $ |MF_GRENADEBOUNCE|MF_MISSILE
	end
	if (other and other.valid) and (other.flags & MF_BOSS)
	and shield.parrytime > 0 
		P_InstaThrust(other,shield.angle,FRACUNIT*thrustspeed)
		P_DamageMobj(other, shield, shield)
		S_StartSound(shield, sound2)
	end
end, MT_PLAYER)

addHook("PostThinkFrame", do
	for player in players.iterate
		if not ((player and player.valid) and (player.mo and player.mo.valid)) continue end
		if player.mo.skin ~= "tatails"
			continue
		end
		
		if player.mo.parrytime > 0
		and (player.mo.state ~= S_HELM or player.mo.state ~= S_HELMB)
			if player.mo.state == S_HELM
				continue
			end
			player.mo.state = S_HELMB
		end
	end
end)