--[[ 
this script defines all the freeslots we need so here so they aren't
lost inbetween the rest of the code
As long as this script is loaded first we can assume every freeslot exists
(Useful when multiple scripts need a specific freeslot)
- Silic
]]--

//Powerup Freeslots and States
freeslot(--Sprites
	 "SPR_PWHM", 
	 "SPR_PWRB", 
	 "SPR_PWRD", 
	 "SPR_PWNP", 
	 "SPR_PWRN",
	 "SPR_BIGB",
	 "SPR_NAPM", 
	 "SPR_NAPF",
	 "SPR_EXPL",  
	 "SPR_PWBB", 
	 "SPR_TCTL", 
	 "SPR_RBSD", 
	 "SPR_RBWA", 
	 "SPR_RBFL",
	 "SPR_PWSC",
	 "SPR_PWFG",
	 "SPR_PWTL",
	 "SPR_PWBI",
	 "SPR_PWNV",
	 "SPR_PWRR",
	 "SPR_PWTB",
	 "SPR_PWMS",
	 "SPR_PWGL",
	 "SPR_RBTR",
	 "SPR_RBSB",
	 "SPR_TASB",
	 "SPR_TARG",
	 "SPR_RBSI",
	 "SPR_SBPL",
	 
	 --Sound Effects
	 "SFX_FINDI",
	 "SFX_EXPLD", 
	 "SFX_TARING",
	 "SFX_ENTER",
	 "SFX_SWITCH",
	 "SFX_TATELE",
	 "SFX_SUBLM",
	 
	 --States
	 "S_TAILS_RING",
	 "S_HELMETPOWER", 
	 "S_ROBOTPOWER", 
	 "S_ROBOT_TAILS", 
	 "S_RAIDOPOWER", 
	 "S_NAPALMPOWER", 
	 "S_RUNPOWER",
	 "S_SONICPOWER",
	 "S_FANGPOWER",
	 "S_TELEPOWER",
	 "S_BIGPOWER",
	 "S_TRIPLEPOWER",
	 "S_NIGHTVISIONPOWER",
	 "S_RADARPOWER",
	 "S_GLOVEPOWER",
	 "S_NAPALMPRO",
	 "S_LARGEPRO", 
	 "S_PELLETPRO",
	 "S_NAP_EXPLODE",
	 "S_LARGE_EXPLODE",
	 "S_ROCKET_EXPLODE",
	 "S_TAILS_ROBOT", 
	 "S_TAILS_ROBOFLY",
	 "S_TAILS_ROBOFLY2",
	 "S_TAILS_ROBOWALK",
	 "S_TAILS_ROBOTRANS1",
	 "S_TAILS_ROBOTRANS2",
	 "S_TAILS_SUBBING",
	 "S_TAILS_NIGHTINVIS",
	 
	 --Mobjs
	 "MT_TARING",
	 "MT_HELMET", 
	 "MT_ROBOT", 
	 "MT_ROBOTPRO", 
	 "MT_RAIDO", 
	 "MT_NAPALM", 
	 "MT_RUNSHOE",
	 "MT_TASONIC",
	 "MT_TAFANG",
	 "MT_TELEPORT",
	 "MT_BIGBOMB",
	 "MT_TRIPLE",
	 "MT_GLOVE",
	 "MT_RADAR",
	 "MT_NIGHTVISION",
	 "MT_NAPALMPRO",
	 "MT_LARGEPRO",
	 "MT_PELLETPRO",
	 "MT_REALROBOT",
	 "MT_ROBOSUB",
	 "MT_NIGHTVISIONPRO",
	 "MT_NIGHTVISIONPRO1"
)

//TA Ring Stuff
states[S_TAILS_RING] = {
	sprite = SPR_TARG,
	frame = A|FF_ANIMATE,
	tics = 20,
	var1 = 3,
	var2 = 5,
	nextstate = S_TAILS_RING
}
mobjinfo[MT_TARING] = {
	doomednum = -1,
	spawnstate = S_TAILS_RING,
	deathstate = S_SPRK1,
	deathsound = sfx_taring,
	spawnhealth = 1000,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	flags = MF_SLIDEME|MF_SPECIAL
}

//Powerups
states[S_HELMETPOWER] = {SPR_PWHM, nil, -1, nil, 0, 0, S_HELMETPOWER}
states[S_ROBOTPOWER] = {SPR_PWRB, nil, -1, nil, 0, 0, S_ROBOTPOWER}
states[S_RAIDOPOWER] = {SPR_PWRD, nil, -1, nil, 0, 0, S_RAIDOPOWER}
states[S_NAPALMPOWER] = {SPR_PWNP, nil, -1, nil, 0, 0, S_NAPALMPOWER}
states[S_RUNPOWER] = {SPR_PWRN, nil, -1, nil, 0, 0, S_RUNPOWER}
states[S_SONICPOWER] = {SPR_PWSC, nil, -1, nil, 0, 0, S_SONICPOWER}
states[S_FANGPOWER] = {SPR_PWFG, nil, -1, nil, 0, 0, S_FANGPOWER}
states[S_TELEPOWER] = {SPR_PWTL, nil, -1, nil, 0, 0, S_TELEPOWER}
states[S_BIGPOWER] = {SPR_PWBI, nil, -1, nil, 0, 0, S_BIGPOWER}
states[S_TRIPLEPOWER] = {SPR_PWTB, nil, -1, nil, 0, 0, S_TRIPLEPOWER}
states[S_GLOVEPOWER] = {SPR_PWGL, nil, -1, nil, 0, 0, S_GLOVEPOWER}
states[S_RADARPOWER] = {SPR_PWRR, nil, -1, nil, 0, 0, S_RADARPOWER}
states[S_NIGHTVISIONPOWER] = {SPR_PWNV, nil, -1, nil, 0, 0, S_NIGHTVISIONPOWER}
states[S_NAPALMPRO] = {SPR_NAPM, FF_ANIMATE|A, -1, A_LobShot, 1, 3, nil}
states[S_LARGEPRO] = {SPR_BIGB, FF_ANIMATE|A, -1, A_LobShot, 1, 3, nil}
states[S_PELLETPRO] = {SPR_SBPL, A, -1, A_LobShot, 0, 0, nil}
states[S_TAILS_NIGHTINVIS] = {SPR_NULL, nil, -1, nil, 0, 0, S_TAILS_NIGHTINVIS}
states[S_NAP_EXPLODE] = {
	sprite = SPR_NAPF,
	frame = FF_ANIMATE|A,
	tics = 80,
	action = A_Explode,
	var1 = 1,
	var2 = 4,
	nextstate = S_NULL
}
states[S_LARGE_EXPLODE] = {
	sprite = SPR_EXPL,
	frame = FF_ANIMATE|A,
	tics = 42,
	action = A_Explode,
	var1 = 14,
	var2 = 3,
	nextstate = S_NULL
}
mobjinfo[MT_NIGHTVISIONPRO] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 10*FRACUNIT,
	height = 5*FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIPTHING
}
//Robot Tails State
states[S_ROBOT_TAILS] = {
	sprite = SPR_TCTL,
	frame = FF_ANIMATE|A,
	tics = 30,
	var1 = 3,
	var2 = 8,
	nextstate = S_ROBOT_TAILS
}
states[S_TAILS_SUBBING] = {
	sprite = SPR_TASB,
	frame = A|FF_ANIMATE,
	tics = 8,
	var1 = 1,
	var2 = 4,
	nextstate = S_TAILS_SUBBING
}
	
//Robot Mobj State
states[S_TAILS_ROBOT] = {
	sprite = SPR_RBSD,
	tics = 1,
	nextstate = S_TAILS_ROBOT
}
states[S_TAILS_ROBOWALK] = {
	sprite = SPR_RBWA,
	frame = FF_ANIMATE|A,
	tics = 30,
	var1 = 3,
	var2 = 8,
	nextstate = S_TAILS_ROBOWALK
}
states[S_TAILS_ROBOFLY] = {
	sprite = SPR_RBFL,
	frame = FF_ANIMATE|A,
	tics = 23,
	var1 = 7,
	var2 = 3,
	nextstate = S_TAILS_ROBOFLY2
}
states[S_TAILS_ROBOFLY2] = {
	sprite = SPR_RBFL,
	frame = FF_ANIMATE|J,
	tics = 6,
	var1 = 1,
	var2 = 3,
	nextstate = S_TAILS_ROBOFLY2
}
states[S_TAILS_ROBOTRANS1] = {
	sprite = SPR_RBTR,
	frame = A|FF_ANIMATE,
	tics = 35,
	var1 = 6,
	var2 = 5,
	nextstate = S_TAILS_ROBOTRANS2
}
states[S_TAILS_ROBOTRANS2] = {
	sprite = SPR_RBSB,
	tics = -1,
	nextstate = S_TAILS_ROBOTRANS2
}

//Powerup Objects
mobjinfo[MT_HELMET] = {
	doomednum = -1,
	spawnstate = S_HELMETPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_ROBOT] = {
	doomednum = -1,
	spawnstate = S_ROBOTPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_RAIDO] = {
	doomednum = -1,
	spawnstate = S_RAIDOPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_NAPALM] = {
	doomednum = -1,
	spawnstate = S_NAPALMPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_RUNSHOE] = {
	doomednum = -1,
	spawnstate = S_RUNPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_TASONIC] = {
	doomednum = -1,
	spawnstate = S_SONICPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_TAFANG] = {
	doomednum = -1,
	spawnstate = S_FANGPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_TELEPORT] = {
	doomednum = -1,
	spawnstate = S_TELEPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_BIGBOMB] = {
	doomednum = -1,
	spawnstate = S_BIGPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_TRIPLE] = {
	doomednum = -1,
	spawnstate = S_TRIPLEPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_GLOVE] = {
	doomednum = -1,
	spawnstate = S_GLOVEPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_NIGHTVISION] = {
	doomednum = -1,
	spawnstate = S_NIGHTVISIONPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
mobjinfo[MT_RADAR] = {
	doomednum = -1,
	spawnstate = S_RADARPOWER,
	deathstate = S_NULL,
	deathsound = sfx_findi,
	radius = 24*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

//Bomb Projectiles
mobjinfo[MT_NAPALMPRO] = {
	spawnstate = S_NAPALMPRO,
	spawnhealth = 1,
	height = 40*FRACUNIT,
	radius = 18*FRACUNIT,
	speed = 25*FRACUNIT,
	seesound = sfx_s3k51,
	deathstate = S_NAP_EXPLODE,
	damage = 50*FRACUNIT,
	deathsound = sfx_s1ae,
	flags = MF_MISSILE
}
mobjinfo[MT_LARGEPRO] = {
	spawnstate = S_LARGEPRO,
	spawnhealth = 1,
	height = 40*FRACUNIT,
	radius = 18*FRACUNIT,
	speed = 25*FRACUNIT,
	seesound = sfx_s3k51,
	deathstate = S_LARGE_EXPLODE,
	damage = 500*FRACUNIT,
	deathsound = sfx_expld
}
mobjinfo[MT_PELLETPRO] = {
	spawnstate = S_PELLETPRO,
	spawnhealth = 1,
	height = 40*FRACUNIT,
	radius = 18*FRACUNIT,
	speed = 25*FRACUNIT,
	deathstate = S_ROCKET_EXPLODE,
	damage = 50*FRACUNIT,
	flags = MF_MISSILE|MF_NOGRAVITY
}
//Actual Robot Stuff
mobjinfo[MT_ROBOTPRO] = {
	spawnstate = S_ROBOT_TAILS,
	spawnhealth = 100,
	height = 40*FRACUNIT,
	radius = 18*FRACUNIT,
	speed = 10*FRACUNIT,
	seesound = sfx_cdfm47,
	deathstate = S_NULL,
	damage = 5*FRACUNIT,
}
mobjinfo[MT_ROBOSUB] = {
	spawnstate = S_TAILS_ROBOTRANS1,
	spawnhealth = 100,
	height = 40*FRACUNIT,
	radius = 18*FRACUNIT,
	deathstate = S_NULL,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

//Tails S2 Waiting Stuff
/*freeslot("S_TAILS_WAIT", "S_TAILS_WAIT2", "SPR_TWAI")
states[S_TAILS_WAIT] = {
	sprite = ,
	frame = FF_ANIMATE|A,
	tics = 3,
	var1 = 0,
	var2 = 3,
	nextstate = S_TAILS_WAIT2
}
states[S_TAILS_WAIT2] = {
	sprite = ,
	frame = FF_ANIMATE|A,
	tics = ,
	var1 = ,
	var2 = ,
	nextstate = S_TAILS_WAIT2
}*/

//Emote Stuff
freeslot("SPR2_TASP", "S_TAILSPIN", "S_UPSIDE", "SPR2_TUPD", "SPR2_TDNC", "S_TPIPE")
freeslot("SPR2_TASL", "SPR2_TASE", "SPR2_TDED", "S_TAILS_SLEEP", "S_TAILS_SLEEP2", "S_TAILS_DEAD", "S_TAILS_DEAD2", "SPR2_TADD")

states[S_TAILSPIN] = {
	sprite = SPR_PLAY, 
	frame = SPR2_TASP, 
	tics = 3, 
	nextstate = S_TAILSPIN
}
states[S_UPSIDE] = {
	sprite = SPR_PLAY, 
	frame = SPR2_TUPD, 
	tics = 4, 
	nextstate = S_UPSIDE
}
states[S_TPIPE] = {
	sprite = SPR_PLAY, 
	frame = SPR2_TDNC, 
	tics = 3, 
	nextstate = S_TPIPE
}
states[S_TAILS_SLEEP] = {
	sprite = SPR_PLAY,
	frame = SPR2_TASL,
	tics = 4,
	var1 = 0,
	var2 = 4,
	nextstate = S_TAILS_SLEEP2
}
states[S_TAILS_SLEEP2] = {
	sprite = SPR_PLAY,
	frame = SPR2_TASE,
	tics = 40,
	var1 = 1,
	var2 = 20,
	nextstate = S_TAILS_SLEEP2
}
states[S_TAILS_DEAD] = {
	sprite = SPR_PLAY,
	frame = SPR2_TDED|FF_ANIMATE,
	tics = 12,
	var1 = 1,
	var2 = 6,
	nextstate = S_TAILS_DEAD2
}
states[S_TAILS_DEAD2] = {
	sprite = SPR_PLAY,
	frame = SPR2_TADD,
	tics = -1,
	nextstate = S_TAILS_DEAD2
}

//Falling With Style
freeslot("SPR2_TCOR", "S_TAILS_CORK")
states[S_TAILS_CORK] = {
	sprite = SPR_PLAY,
	frame = SPR2_TCOR|FF_ANIMATE|A,
	tics = 33,
	var1 = 11,
	var2 = 3,
	nextstate = S_TAILS_CORK
}

//Victory Animation Stuff
freeslot("S_TVICTORY1","S_TVICTORY2", "SPR_MIVC")

states[S_TVICTORY1] = {
	sprite = SPR_MIVC,
	frame = FF_ANIMATE|A,
	tics = 57,
	var1 = 19,
	var2 = 3,
	nextstate = S_TVICTORY2
}
states[S_TVICTORY2] = {
	sprite = SPR_MIVC,
	frame = T,
	tics = 1,
	nextstate = S_TVICTORY2
}

//Powerup Obtained Things
freeslot("S_TAILS_PICKUP", "S_TAILS_PICKUP2", "S_TAILS_AWAY", "SPR2_OBTN", "SPR2_OBTM", "SFX_SLECT")

states[S_TAILS_PICKUP] = {
	sprite = SPR_PLAY,
	frame = SPR2_OBTN|FF_ANIMATE|A,
	tics = 24,
	var1 = 2,
	var2 = 8,
	nextstate = S_TAILS_PICKUP2
}
states[S_TAILS_PICKUP2] = {
	sprite = SPR_PLAY,
	frame = SPR2_OBTM|A,
	tics = 24,
	var1 = 0,
	var2 = 1,
	nextstate = S_TAILS_AWAY
}
states[S_TAILS_AWAY] = {
	sprite = SPR_PLAY,
	frame = SPR2_OBTM|FF_ANIMATE,
	tics = 16,
	var1 = 1,
	var2 = 8,
	nextstate = S_PLAY_STND
}

//Helmet Things
freeslot("S_HELM", "S_HELMB", "SPR_HELM")

states[S_HELM] = {
	sprite = SPR_HELM,
	frame = FF_ANIMATE|A,
	tics = 10,
	var1 = 1,
	var2 = 5,
	nextstate = S_HELMB
}
states[S_HELMB] = {
	sprite = SPR_HELM,
	frame = FF_ANIMATE|C,
	tics = 70,
	var1 = 0,
	var2 = 70,
	nextstate = S_PLAY_STND
}

//Bomb Throw Things
freeslot("S_BTHROW", "SPR_TABB")

states[S_BTHROW] = {
	sprite = SPR_TABB,
	frame = FF_ANIMATE|A,
	tics = 8,
	var1 = 3,
	var2 = 2,
	nextstate = S_PLAY_STND
}

//Menuing
freeslot("S_TAILS_MENU", "SPR2_TAMU")

states[S_TAILS_MENU] = {
	sprite = SPR_PLAY,
	frame = SPR2_TAMU,
	tics = 18,
	var1 = 2,
	var2 = 6,
	nextstate = S_TAILS_MENU
}

//House Things
freeslot("SPR_HOUS", "S_TAILS_HOUSE", "MT_HOUSE")

states[S_TAILS_HOUSE] = {
	sprite = SPR_HOUS,
	frame = A,
	tics = -1
}

mobjinfo[MT_HOUSE] = {
	doomednum = -1,
	spawnstate = S_TAILS_HOUSE,
	height = 115*FRACUNIT,
	radius = 45*FRACUNIT,
	flags = MF_SPECIAL
}

//Teleporting Stuff
freeslot("SPR2_TATP", "S_TAILS_TELEPORT")
states[S_TAILS_TELEPORT] = {
	sprite = SPR_PLAY,
	frame = SPR2_TATP|A|FF_ANIMATE,
	tics = 28,
	var1 = 6,
	var2 = 4,
	nextstate = S_TAILS_TELEPORT
}

rawset(_G, "gettapowerups", function()
	if multiplayer return 0 end
	
	local powerups = GlobalBanks_Array[7]
	return powerups
end)

rawset(_G, "savetapowerups", function(map)
	local powerups = GlobalBanks_Array[7]
	
	if not (powerups & map)
		GlobalBanks_Array[7] = powerups|map
	end
end)